// PutPixel in 16-bit mode by Don Miguel 
// specially for _mp_    ^_-

#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpstdio.h"

GPDRAWSURFACE gpDraw[2];	// Priamry & Back SURFACE ^_^ only 2 for 16-bit
GPDRAWTAG gpdrawtag;
int nflip;	// Flip Index

void FlipAndShow(void);
void Delay(int ms);
void PutPixel(int x, int y, int c);

void GpMain(void * arg)
{		
	int i,j,t,keydata;
	unsigned short	*p_buf;

	int x,y;
	
	//set our pen to the centre of the screen
	x=160; y=120;
		
	//16bit mode set
	i = GpGraphicModeSet(16, NULL);
	i = GpLcdSurfaceGet(&gpDraw[0], 0);   
    i = GpLcdSurfaceGet(&gpDraw[1], 1);
	GpSurfaceSet(&gpDraw[1]);
		
    nflip = 0;

	t=0;
//-- start clear screen (2 surfaces)
// here was a funky-screen-fill.. but..
    p_buf = (unsigned short *)(gpDraw[nflip].ptbuffer);
    	for ( i=0; i<320; i++)
    	{
    		for ( j=0; j<240; j++ )
    		{
	    			*(p_buf + i*240 + j) = t++;	//0xffff - for WHITE colour
    		}
	    }
		p_buf = (unsigned short *)(gpDraw[++nflip].ptbuffer);
		nflip &= 0x01;
	t=0;
    	for ( i=0; i<320; i++)
    	{
    		for ( j=0; j<240; j++ )
    		{
	    			*(p_buf + i*240 + j) = t++;	//0xffff - for WHITE colour
    		}
	    }
//-- end clear screen
	
//main cycle	
	keydata = 0;
	while(1)
	{
		//keyboard
		if ( keydata & GPC_VK_UP ) //press UP
		{
			y--;
			if (y<0)
			{
				y = 0;
			}
		}
		if ( keydata & GPC_VK_DOWN ) //press DOWN
		{
			y++;
			if (y>=240)
			{
				y = 239;
			}
		}

		if ( keydata & GPC_VK_LEFT ) //press LEFT
		{
			x--;
			if (x<0)
			{
				x = 0;
			}
		}
		if ( keydata & GPC_VK_RIGHT ) //press RIGHT
		{
			x++;
			if (x>=320)
			{
				x = 319;
			}
		}
		if ( keydata == (GPC_VK_START | GPC_VK_SELECT)) //press Start+Select
		{
			//reset
			GpAppExit();
		}


		PutPixel(x,y,t++);

		FlipAndShow();

 		//  
		Delay(50);
		GpKeyGetEx(&keydata);
	}
	
	GpAppExit(); 
}


void FlipAndShow(void)
{
	//flip and show hidden surface		
		GpSurfaceFlip(&gpDraw[nflip++]);
		nflip %= 2;
}

void Delay(int ms) {
	unsigned int ticks;
	ticks=GpTickCountGet();
	while(GpTickCountGet()-ticks<ms);
}

//sets a pixel in 16-bit mode 
void PutPixel(int x, int y, int c)
{
	// you can optimize this function...
	// i did not add here any pixels range conditions
	// checking...
	// x = 0..319      y = 0..239 
	unsigned short *p_buf;
	p_buf = (unsigned short *)(gpDraw[nflip].ptbuffer);
	*(p_buf + x*240 + (239-y)) = c;
}

// Peace!!!
// check my site for more free sources
// http://gp32.chat.ru

// post your demos / sources on my GP32 board
// http://pub61.ezboard.com/bgp32

// Don Miguel             7 Apr 2002